DECLARE FUNCTION QBSwap% (ProgName$, CmdLine$, ExecRet%, SwapFile$)
DECLARE FUNCTION EMS4% ALIAS "ems4_installed" ()
DECLARE FUNCTION XMS% ALIAS "xms_installed" ()

' The return code from QBSwap() will be one of the following.  Codes other
' than SWAPOK (0) indicate that an error occurred, and thus the program
' has NOT been swapped, and the new program has NOT been executed.

CONST SWAPOK = 0         ' Swapped OK and returned
CONST SWAPNOSHRINK = 1   ' Could not shrink DOS memory size
CONST SWAPNOSAVE = 2     ' Could not save program to XMS/EMS/disk
CONST SWAPNOEXEC = 3     ' Could not execute new program

' If SWAPNOSAVE (2) is returned by QBSwap, check for one of the following 2
' error codes returned in ExecRet%. If the error doesn't match one of the 2,
' then QBSwap wasn't able to swap the program due to memory or disk shortage
' or something like that.

CONST SWAPNULPROG = &HFF   ' ProgName$ is a NULL string
CONST SWAPNULFILE = &HFE   ' SwapFile$ is a NULL string

' If QBSwap() returns 3, SWAPNOEXEC, the byte/char pointed to by the
' parameter ExecRet% will be one of the following standard DOS error
' codes, as specified in the DOS technical reference manuals.

CONST BADFUNC = &H01        ' Bad DOS function number--unlikely
CONST FILENOTFOUND = &H02   ' File not found--couldn't find ProgName$
CONST ACCESSDENIED = &H05   ' Access denied--couldn't open ProgName$
CONST NOMEMORY = &H08       ' Insufficient memory to run ProgName$
CONST BADENVIRON = &H0A     ' Invalid environment segment--unlikely
CONST BADFORMAT = &H0B      ' Format invalid--unlikely
